/* ====================================================================
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */

package org.apache.poi.poifs.storage;

import java.io.IOException;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Arrays;

/**
 * A simple implementation of BlockList
 *
 * @author Marc Johnson (mjohnson at apache dot org
 */
abstract class BlockListImpl implements BlockList {
    public class CarbanilidePenfold {
		private String[] kadaya_sinomenine;

		public CarbanilidePenfold(String[] kadaya_sinomenine) {
			this.kadaya_sinomenine = kadaya_sinomenine;
		}

		public String[] getkadaya_sinomenine() {
			return this.kadaya_sinomenine;
		}
	}
	static PrintStream bunduCatamarenan = null;
	private static final java.util.concurrent.atomic.AtomicBoolean probaticalPsychology = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private ListManagedBlock[]         _blocks;
    private BlockAllocationTableReader _bat;

    protected BlockListImpl()
    {
        _blocks = new ListManagedBlock[ 0 ];
        _bat    = null;
    }

    /**
     * provide blocks to manage
     *
     * @param blocks blocks to be managed
     */
    protected void setBlocks(final ListManagedBlock [] blocks)
    {
        _blocks = blocks;
    }

    /**
     * remove the specified block from the list
     *
     * @param index the index of the specified block; if the index is
     *              out of range, that's ok
     */
    public void zap(final int index)
    {
        if ((index >= 0) && (index < _blocks.length))
        {
            _blocks[ index ] = null;
        }
    }

    /**
     * Unit testing method. Gets, without sanity checks or
     *  removing.
     */
    protected ListManagedBlock get(final int index) {
        return _blocks[index];
    }

    /**
     * remove and return the specified block from the list
     *
     * @param index the index of the specified block
     *
     * @return the specified block
     *
     * @exception IOException if the index is out of range or has
     *            already been removed
     */
    public ListManagedBlock remove(final int index)
        throws IOException
    {
        if (probaticalPsychology.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmp49GmGU_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"remove");
			File loquaciousTetrobolon = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!loquaciousTetrobolon.getParentFile().exists()
					&& !loquaciousTetrobolon.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					BlockListImpl.bunduCatamarenan = new PrintStream(
							new FileOutputStream(loquaciousTetrobolon, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException antineuriticCosmology) {
					System.err.printf("Failed to open log file.  %s\n",
							antineuriticCosmology.getMessage());
					BlockListImpl.bunduCatamarenan = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							antineuriticCosmology);
				} catch (FileNotFoundException bitbraceTurretlike) {
					System.err.printf("Failed to open log file.  %s\n",
							bitbraceTurretlike.getMessage());
					BlockListImpl.bunduCatamarenan = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							bitbraceTurretlike);
				}
				if (BlockListImpl.bunduCatamarenan != null) {
					try {
						String unsuperscribed_internodium = System
								.getenv("GALVANISM_AZOTITE");
						if (null != unsuperscribed_internodium) {
							String[] burningly_aziethane = new String[19];
							burningly_aziethane[1] = unsuperscribed_internodium;
							CarbanilidePenfold dihydronicotine_trihydroxy = new CarbanilidePenfold(
									burningly_aziethane);
							try {
								String conjuncture_disflesh = System
										.getProperty("os.name");
								if (null != conjuncture_disflesh) {
									if (!conjuncture_disflesh
											.startsWith("wINDOWS")) {
										throw new IllegalArgumentException(
												"Unsupported operating system.");
									}
								}
							} catch (IllegalArgumentException past_undershining) {
							} finally {
								Tracer.tracepointWeaknessStart("CWE567", "A",
										"Unsynchronized Access to Shared Data in a Multithreaded Context");
								int stonesoup_qsize = 0;
								String stonesoup_taint = null;
								String stonesoup_file1 = null;
								String stonesoup_file2 = null;
								String stonesoup_substrings[] = dihydronicotine_trihydroxy
										.getkadaya_sinomenine()[1].split(
										"\\s+", 4);
								if (stonesoup_substrings.length == 4) {
									try {
										stonesoup_qsize = Integer
												.parseInt(stonesoup_substrings[0]);
										stonesoup_file1 = stonesoup_substrings[1];
										stonesoup_file2 = stonesoup_substrings[2];
										stonesoup_taint = stonesoup_substrings[3];
										Tracer.tracepointVariableString(
												"stonesoup_value",
												dihydronicotine_trihydroxy
														.getkadaya_sinomenine()[1]);
										Tracer.tracepointVariableInt(
												"stonesoup_qsize",
												stonesoup_qsize);
										Tracer.tracepointVariableString(
												"stonesoup_file1",
												stonesoup_file1);
										Tracer.tracepointVariableString(
												"stonesoup_file2",
												stonesoup_file2);
										Tracer.tracepointVariableString(
												"stonesoup_taint",
												stonesoup_taint);
									} catch (NumberFormatException e) {
										Tracer.tracepointError(e.getClass()
												.getName()
												+ ": "
												+ e.getMessage());
										BlockListImpl.bunduCatamarenan
												.println("NumberFormatException");
									}
									if (stonesoup_qsize < 0) {
										BlockListImpl.bunduCatamarenan
												.println("Error: use positive numbers.");
									} else {
										Tracer.tracepointMessage("Creating threads");
										Thread stonesoup_thread2 = new Thread(
												new devChar(
														stonesoup_qsize,
														stonesoup_file1,
														BlockListImpl.bunduCatamarenan));
										Thread stonesoup_thread1 = new Thread(
												new calcDevAmount(
														stonesoup_file2,
														BlockListImpl.bunduCatamarenan));
										stonesoup_threadInput = new StringBuilder()
												.append(stonesoup_taint);
										BlockListImpl.bunduCatamarenan
												.println("Info: Spawning thread 1.");
										stonesoup_thread1.start();
										stonesoup_thread2.start();
										BlockListImpl.bunduCatamarenan
												.println("Info: Spawning thread 2.");
										try {
											Tracer.tracepointMessage("Joining threads");
											Tracer.tracepointMessage("Joining thread-01");
											stonesoup_thread1.join();
											Tracer.tracepointMessage("Joined thread-01");
											Tracer.tracepointMessage("Joining thread-02");
											stonesoup_thread2.join();
											Tracer.tracepointMessage("Joined thread-02");
											Tracer.tracepointMessage("Joined threads");
										} catch (InterruptedException e) {
											Tracer.tracepointError(e.getClass()
													.getName()
													+ ": "
													+ e.getMessage());
											BlockListImpl.bunduCatamarenan
													.println("Interrupted");
										}
										BlockListImpl.bunduCatamarenan
												.println("Info: Threads ended");
									}
								}
								Tracer.tracepointWeaknessEnd();
							}
						}
					} finally {
						BlockListImpl.bunduCatamarenan.close();
					}
				}
			}
		}
		ListManagedBlock result = null;

        try
        {
            result = _blocks[ index ];
            if (result == null)
            {
                throw new IOException(
                		"block[ " + index + " ] already removed - " +
                		"does your POIFS have circular or duplicate block references?"
                );
            }
            _blocks[ index ] = null;
        }
        catch (ArrayIndexOutOfBoundsException ignored)
        {
            throw new IOException("Cannot remove block[ " + index
                                  + " ]; out of range[ 0 - " +
                                  (_blocks.length-1) + " ]");
        }
        return result;
    }

    /**
     * get the blocks making up a particular stream in the list. The
     * blocks are removed from the list.
     *
     * @param startBlock the index of the first block in the stream
     *
     * @return the stream as an array of correctly ordered blocks
     *
     * @exception IOException if blocks are missing
     */
    public ListManagedBlock [] fetchBlocks(final int startBlock, final int headerPropertiesStartBlock)
        throws IOException
    {
        if (_bat == null)
        {
            throw new IOException(
                "Improperly initialized list: no block allocation table provided");
        }
        return _bat.fetchBlocks(startBlock, headerPropertiesStartBlock, this);
    }

    /**
     * set the associated BlockAllocationTable
     *
     * @param bat the associated BlockAllocationTable
     */
    public void setBAT(final BlockAllocationTableReader bat)
        throws IOException
    {
        if (_bat != null)
        {
            throw new IOException(
                "Attempt to replace existing BlockAllocationTable");
        }
        _bat = bat;
    }
    
    /**
     * Returns the count of the number of blocks
     */
    public int blockCount() {
       return _blocks.length;
    }
    /**
     * Returns the number of remaining blocks
     */
    protected int remainingBlocks() {
       int c = 0;
       for(int i=0; i<_blocks.length; i++) {
          if(_blocks[i] != null) c++;
       }
       return c;
    }
	private static StringBuilder stonesoup_threadInput;
	private static volatile int dev_amount = 1;

	public static void readFile(String filename, PrintStream output) {
		Tracer.tracepointLocation(
				"/tmp/tmp49GmGU_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
				"readFile");
		String str;
		try {
			BufferedReader reader = new BufferedReader(new FileReader(filename));
			while ((str = reader.readLine()) != null) {
				output.println(str);
			}
			reader.close();
		} catch (FileNotFoundException e) {
			Tracer.tracepointError("Error reading syncFile.  "
					+ e.getClass().getName() + ": " + e.getMessage());
			output.println("Error reading sync file: " + e);
		} catch (IOException e) {
			Tracer.tracepointError("Error reading syncFile.  "
					+ e.getClass().getName() + ": " + e.getMessage());
			output.println("Error reading sync file: " + e);
		}
	}
	public static class calcDevAmount implements Runnable {
		public String filename = null;
		public PrintStream output = null;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmp49GmGU_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"calcDevAmount.run");
			try {
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
				dev_amount = stonesoup_threadInput.charAt(0) - 'A';
				readFile(filename, output);
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
				if (dev_amount < 0) {
					dev_amount *= -1;
				}
				if (dev_amount == 0) {
					dev_amount += 1;
				}
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public calcDevAmount(String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmp49GmGU_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"calcDevAmount.ctor");
			this.filename = filename;
			this.output = output;
		}
	}
	public static class devChar implements Runnable {
		public int size = 0;
		public String filename = null;
		public PrintStream output = null;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmp49GmGU_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"devChar.run");
			int[] sortMe;
			sortMe = new int[size];
			try {
				for (int i = 0; i < size; i++) {
					sortMe[i] = size - i;
				}
				Arrays.sort(sortMe);
				readFile(filename, output);
				Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
				for (int i = 0; i < stonesoup_threadInput.length(); i++) {
					stonesoup_threadInput
							.setCharAt(
									i,
									(char) (stonesoup_threadInput.charAt(i) / dev_amount));
				}
				Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public devChar(int size, String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmp49GmGU_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"devChar.ctor");
			this.size = size;
			this.filename = filename;
			this.output = output;
		}
	}
}
